## com.lowagie.bc.asn1
Class DERUTCTime

    java.lang.Object
      com.lowagie.bc.asn1.DERObject
          com.lowagie.bc.asn1.DERUTCTime

All Implemented Interfaces:
  DEREncodable, DERTags

    public class DERUTCTime

extends DERObject

UTC time object.

Field Summary
`(package private) java.lang.String` `time`

Fields inherited from interface com.lowagie.bc.asn1.DERTags
`APPLICATION, BIT_STRING, BMP_STRING, BOOLEAN, CONSTRUCTED, ENUMERATED, EXTERNAL, GENERAL_STRING, GENERALIZED_TIME, GRAPHIC_STRING, IA5_STRING, INTEGER, NULL, NUMERIC_STRING, OBJECT_IDENTIFIER, OCTET_STRING, PRINTABLE_STRING, SEQUENCE, SEQUENCE_OF, SET, SET_OF, T61_STRING, TAGGED, UNIVERSAL_STRING, UTC_TIME, UTF8_STRING, VIDEOTEX_STRING, VISIBLE_STRING`

Constructor Summary
`DERUTCTime(byte[] bytes)`
`DERUTCTime(java.util.Date time)` base constructer from a java.util.date object
`DERUTCTime(java.lang.String time)` The correct format for this is YYMMDDHHMMSSZ (it used to be that seconds were never encoded.

Method Summary
`(package private) void` `encode(DEROutputStream out)`
`boolean` `equals(java.lang.Object o)`
`java.lang.String` `getAdjustedTime()` return the time as an adjusted date with a 4 digit year.
`static DERUTCTime` `getInstance(ASN1TaggedObject obj, boolean explicit)` return an UTC Time from a tagged object.
`static DERUTCTime` `getInstance(java.lang.Object obj)` return an UTC Time from the passed in object.
`private byte[]` `getOctets()`
`java.lang.String` `getTime()` return the time - always in the form of YYMMDDhhmmssGMT(+hh:mm|-hh:mm).

Methods inherited from class com.lowagie.bc.asn1.DERObject
`getDERObject`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### time

    java.lang.String time

Constructor Detail

### DERUTCTime

    public DERUTCTime(java.lang.String time)

  The correct format for this is YYMMDDHHMMSSZ (it used to be that seconds were never encoded. When you're creating one of these objects from scratch, that's what you want to use, otherwise we'll try to deal with whatever gets read from the input stream... (this is why the input format is different from the getTime() method output).

  Parameters:
    `time` - the time string.

### DERUTCTime

    public DERUTCTime(java.util.Date time)

  base constructer from a java.util.date object

### DERUTCTime

    DERUTCTime(byte[] bytes)

Method Detail

### getInstance

    public static DERUTCTime getInstance(java.lang.Object obj)

  return an UTC Time from the passed in object.

  Throws:
    `java.lang.IllegalArgumentException` - if the object cannot be converted.

### getInstance

    public static DERUTCTime getInstance(ASN1TaggedObject obj,
                                         boolean explicit)

  return an UTC Time from a tagged object.

  Parameters:
    `obj` - the tagged object holding the object we want
    `explicit` - true if the object is meant to be explicitly tagged false otherwise.
  Throws:
    `java.lang.IllegalArgumentException` - if the tagged object cannot be converted.

### getTime

    public java.lang.String getTime()

  return the time - always in the form of YYMMDDhhmmssGMT(+hh:mm|-hh:mm).

  Normally in a certificate we would expect "Z" rather than "GMT", however adding the "GMT" means we can just use:

           dateF = new SimpleDateFormat("yyMMddHHmmssz");

  To read in the time and get a date which is compatible with our local time zone.

  Note: In some cases, due to the local date processing, this may lead to unexpected results. If you want to stick the normal convention of 1950 to 2049 use the getAdjustedTime() method.

### getAdjustedTime

    public java.lang.String getAdjustedTime()

  return the time as an adjusted date with a 4 digit year. This goes in the range of 1950 - 2049.

### getOctets

    private byte[] getOctets()

### encode

    void encode(DEROutputStream out)
          throws java.io.IOException

  Specified by:
    `encode` in class `DERObject`
  Throws:
    `java.io.IOException`

### equals

    public boolean equals(java.lang.Object o)

  Overrides:
    `equals` in class `java.lang.Object`